unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Button1: TButton;
    Button2: TButton;
    Image7: TImage;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure Image4Click(Sender: TObject);
    procedure Image5Click(Sender: TObject);
    procedure Image6Click(Sender: TObject);
    procedure Button1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  i,j,k,l,m,n:integer;
  Stapel:array [1..19] of word;
  Karte:array [1..6] of array [1..5] of word;    
  Summe:array [1..6] of word;
  Zuverteilen:word;

implementation

{$R *.dfm}

Procedure Mischen;
begin
 Stapel[1]:=1;
 Stapel[2]:=2;
 Stapel[3]:=3;
 Stapel[4]:=3;
 Stapel[5]:=3;
 Stapel[6]:=4;
 Stapel[7]:=4;
 Stapel[8]:=4;
 Stapel[9]:=4;
 Stapel[10]:=5;
 Stapel[11]:=5;
 Stapel[12]:=5;
 Stapel[13]:=5;
 Stapel[14]:=6;
 Stapel[15]:=6;
 Stapel[16]:=6;
 Stapel[17]:=6;
 Stapel[18]:=7;
 for i:=1 to 100 do
  for j:=1 to 18 do
   for k:=1 to 18 do
    begin
     l:=Random (2);
     if l=0 then
      begin
       Stapel[19]:=Stapel[j];
       Stapel[j]:=Stapel[k];
       Stapel[k]:=Stapel[19];
      end;
   end;
end;

Procedure Karten_ziehen;
begin
 for i:=1 to 6 do
  for j:=1 to 5 do
   Karte[i,j]:=0;
 for i:=1 to 18 do Karte[(i-1) div 3+1,(i-1) mod 3+1]:=Stapel[i];
end;

Procedure Summen_berechnen;
 var Highest:array [1..6] of word;
begin
 for i:=1 to 6 do Highest[i]:=1;
 for i:=1 to 6 do Summe[i]:=0;
 for i:=1 to 6 do
  for j:=1 to 5 do
   begin
    if Karte[i,Highest[i]]=7 then highest[i]:=highest[i]+1;
    if (Karte[i,j]>Karte[i,Highest[i]]) and (Karte[i,j]<7) then Highest[i]:=j; 
    Summe[i]:=Summe[i]+Karte[i,j];
   end;
 for i:=1 to 6 do for j:=1 to 5 do if Karte[i,j]=7 then Summe[i]:=Summe[i]-7+Karte[i,Highest[i]];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Randomize;
 Memo1.Clear;
 Image1.Picture.LoadFromFile('blank.bmp');
 Image2.Picture.LoadFromFile('blank.bmp');
 Image3.Picture.LoadFromFile('blank.bmp');
 Image4.Picture.LoadFromFile('blank.bmp');
 Image5.Picture.LoadFromFile('blank.bmp');
 Image6.Picture.LoadFromFile('blank.bmp');
 Image7.Picture.LoadFromFile('blank2.bmp');
 Memo1.Color:=Image7.Canvas.Pixels[500,100];
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Mischen;
 Karten_Ziehen;
 Zuverteilen:=3;
 Button2.OnClick (Sender); 
end;

procedure TForm1.Button2Click(Sender: TObject);
var Bild:TBitmap;
    Summen2:array [1..7] of word;
begin
 Bild:=TBitmap.Create;
 Bild.Transparent:=True;
{
//Old 'til Version 2.1
 Image1.Canvas.Brush.Color:=$00469949;
 Image2.Canvas.Brush.Color:=$00469949;
 Image3.Canvas.Brush.Color:=$00469949;
 Image4.Canvas.Brush.Color:=$00469949;
 Image5.Canvas.Brush.Color:=$00469949;
 Image6.Canvas.Brush.Color:=$00469949;
 Image1.Canvas.Rectangle(-10,-10,100,200);
 Image2.Canvas.Rectangle(-10,-10,100,200);
 Image3.Canvas.Rectangle(-10,-10,100,200);
 Image4.Canvas.Rectangle(-10,-10,100,200);
 Image5.Canvas.Rectangle(-10,-10,100,200);
 Image6.Canvas.Rectangle(-10,-10,100,200);
}
//New in Version 2.2
 Image1.Picture.LoadFromFile('blank.bmp');
 Image2.Picture.LoadFromFile('blank.bmp');
 Image3.Picture.LoadFromFile('blank.bmp');
 Image4.Picture.LoadFromFile('blank.bmp');
 Image5.Picture.LoadFromFile('blank.bmp');
 Image6.Picture.LoadFromFile('blank.bmp');
 Image7.Picture.LoadFromFile('blank2.bmp');
//  New in Version 2.2
 for i:=1 to 5 do
  begin
   Bild.LoadFromFile(IntToStr(Karte[1,i])+'.bmp');
   Image1.Canvas.Draw(0,(i-1)*18,Bild);
  end;
 for i:=1 to 5 do
  begin
   Bild.LoadFromFile(IntToStr(Karte[2,i])+'.bmp');
   Image2.Canvas.Draw(0,(i-1)*18,Bild);
  end;
 for i:=1 to 5 do
  begin
   Bild.LoadFromFile(IntToStr(Karte[3,i])+'.bmp');
   Image3.Canvas.Draw(0,(i-1)*18,Bild);
  end;
 for i:=1 to 5 do
  begin
   Bild.LoadFromFile(IntToStr(Karte[4,i])+'.bmp');
   Image4.Canvas.Draw(0,(i-1)*18,Bild);
  end;
 for i:=1 to 5 do
  begin
   Bild.LoadFromFile(IntToStr(Karte[5,i])+'.bmp');
   Image5.Canvas.Draw(0,(i-1)*18,Bild);
  end;
 for i:=1 to 5 do
  begin
   Bild.LoadFromFile(IntToStr(Karte[6,i])+'.bmp');
   Image6.Canvas.Draw(0,(i-1)*18,Bild);
  end;
 //Old 'til Version 2.1
 //Image7.Canvas.Brush.Color:=$00469949;

 //New in Version 2.2:
 Image7.Canvas.Brush.Color:=Memo1.Color;
 Summen_berechnen;
 for i:=1 to 6 do Image7.Canvas.TextOut((i-1)*79+15,180,'   '+IntToStr(Summe[i])+'   ');
 for i:=1 to 6 do Summen2[i]:=Summe[i];
 for i:=1 to 6 do
  for j:=i to 6 do
   if Summen2[i]>Summen2[j] then
    begin
     Summen2[7]:=Summen2[i];
     Summen2[i]:=Summen2[j];
     Summen2[j]:=Summen2[7];
    end;
 Memo1.Clear;
 for i:=1 to 6 do Memo1.Lines.Add(IntToStr(Summen2[i]));
 if zuverteilen>0 then zuverteilen:=zuverteilen-1;
 if Zuverteilen>0 then ShowMessage ('Es ist noch eine '+IntToStr(zuverteilen)+' hinzuzufgen');
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
 if zuverteilen>0 then
  begin
   k:=0;
   repeat
    k:=k+1;
   until Karte[1,k]=0;
   Karte[1,k]:=Zuverteilen;
  end;
 Summen_berechnen;
 for j:=1 to 6 do if Summe[j]>18 then
  begin
   ShowMessage('Keine Summe darf 18 bersteigen!');
   Karte[j,k]:=0;
   Zuverteilen:=Zuverteilen+1;
  end;
 Button2.OnClick(Sender);
end;

procedure TForm1.Image2Click(Sender: TObject);
begin
 if zuverteilen>0 then
  begin
   k:=0;
   repeat
    k:=k+1;
   until Karte[2,k]=0;
   Karte[2,k]:=Zuverteilen;
  end;
 Summen_berechnen;
 for j:=1 to 6 do if Summe[j]>18 then
  begin
   ShowMessage('Keine Summe darf 18 bersteigen!');
   Karte[j,k]:=0;
   Zuverteilen:=Zuverteilen+1;
  end;
 Button2.OnClick(Sender);
end;


procedure TForm1.Image3Click(Sender: TObject);
begin

 if zuverteilen>0 then
  begin
   k:=0;
   repeat
    k:=k+1;
   until Karte[3,k]=0;
   Karte[3,k]:=Zuverteilen;
  end;
 Summen_berechnen;
 for j:=1 to 6 do if Summe[j]>18 then
  begin
   ShowMessage('Keine Summe darf 18 bersteigen!');
   Karte[j,k]:=0;
   Zuverteilen:=Zuverteilen+1;
  end;
 Button2.OnClick(Sender);
end;

procedure TForm1.Image4Click(Sender: TObject);
begin
 if zuverteilen>0 then
  begin
   k:=0;
   repeat
    k:=k+1;
   until Karte[4,k]=0;
   Karte[4,k]:=Zuverteilen;
  end;
 Summen_berechnen;
 for j:=1 to 6 do if Summe[j]>18 then
  begin
   ShowMessage('Keine Summe darf 18 bersteigen!');
   Karte[j,k]:=0;
   Zuverteilen:=Zuverteilen+1;
  end;
 Button2.OnClick(Sender);
end;

procedure TForm1.Image5Click(Sender: TObject);
begin
 if zuverteilen>0 then
  begin
   k:=0;
   repeat
    k:=k+1;
   until Karte[5,k]=0;
   Karte[5,k]:=Zuverteilen;
  end;
 Summen_berechnen;
 for j:=1 to 6 do if Summe[j]>18 then
  begin
   ShowMessage('Keine Summe darf 18 bersteigen!');
   Karte[j,k]:=0;
   Zuverteilen:=Zuverteilen+1;
  end;
 Button2.OnClick(Sender);
end;

procedure TForm1.Image6Click(Sender: TObject);
begin
 if zuverteilen>0 then
  begin
   k:=0;
   repeat
    k:=k+1;
   until Karte[6,k]=0;
   Karte[6,k]:=Zuverteilen;
  end;
 Summen_berechnen;
 for j:=1 to 6 do if Summe[j]>18 then
  begin
   ShowMessage('Keine Summe darf 18 bersteigen!');
   Karte[j,k]:=0;
   Zuverteilen:=Zuverteilen+1;
  end;
 Button2.OnClick(Sender);
end;

procedure TForm1.Button1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var Inhalt:string;
begin
 if Key=112 then
  begin
   Inhalt:='ABOUT';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'Berandors Attribut-Karten-Methode';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'<-------------------------------------------->';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'Version 2.2';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'Idee: Patrick Pricken aka "Berandor"';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'Programmierung: Kai-Uwe Kramer aka "Deus Figendi"';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'Grafiken: Alle selbst gezeichnet ;)';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'Datum: 07.04.2006';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'(F2 fr die echte Hilfe)';
   ShowMessage (Inhalt);
  end;

 if KEy=113 then
  begin
   Inhalt:='HILFE';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'Eigentlich sollte das Programm intuitiv funktionieren...';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'Wie es geht:';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'Als erstes klickt man auf "Karten ziehen", dadurch';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'werden die Karten gemischt und auf sechs Stapel';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'verteilt. Automatisch erscheint eine Benachrichtigung,';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'dass noch 2 Punkte zu verteilen sind. Dies geschieht';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'einfach durch klicken auf den entsprechenden Stapel.';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'Rechts neben den sechs Stapeln';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'ist noch ein Textfeld mit den';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'sortierten Werten. Vor dort aus';
   Inhalt:=Inhalt+Chr(10)+Chr(13);
   Inhalt:=Inhalt+'kann auch kopiert werden.';
   ShowMessage (Inhalt);
  end;
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 Button1.OnKeyDown(Sender,Key,Shift);
end;

end.

